package
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.graphics.Text;
	
	// gamer is a classs fo a game entity, controlled either
	// by local player, remote player or AI or nothing
	public class Enemy extends Entity
	{
		[Embed(source = "gfx/lazors.png")]
		public var GFX:Class;
		
		public static const N:uint = 1;
		public static const E:uint = 2;
		public static const S:uint = 4;
		public static const W:uint = 8;
		
		public static const angle_n:int = 0;
		public static const angle_e:int = 270;
		public static const angle_s:int = 180;
		public static const angle_w:int = 90;
		
		public var spr:Spritemap = new Spritemap(GFX, 32, 32);
		public var px:uint;
		public var py:uint;
		
		public var shadow:Boolean = true;
		
		public var angle:Number = 0;
		public var target_angle:Number = 0;
		
		public var debug:Text = new Text("");
		public var hp:uint = 0;
		public var hit:uint = 0;
		public var setup_delay:uint = 3;
		public function Enemy(x:uint, y:uint)
		{
			// create yourt entity here (look at player class)
			// make sure to alter the properties too (speed, etc)
			spr.add("laser", [0, 1, 2, 3, 2, 1], 12);
			spr.add("blink", [4,4,4,4,4,4,4,4,4,4, 5, 6, 7, 8, 9, 10, 11], 12);
			spr.add("force", [12,13,14,15,16,17], 12);
			spr.add("grenade", [18, 19, 20, 21, 20, 19], 12);
			spr.centerOrigin();
			graphic = spr;
			setHitbox(32, 32, 16, 16);
			
			this.x = x*Q.map.tw+16;
			this.y = y * Q.map.th+16;
			px = x;
			py = y;
			type = "enemy";
			layer = -1;
			
		}

		override public function added():void
		{
			//setup();
		}
		
		public function destroy():Boolean
		{
			if (hit) return false;
			if (hp) 
			{
				hp--;
				hit = 10;
			}
			else {
				FP.world.remove(this);
				Q.map.set_at(px, py, Q.map.get_at(px, py) + 16);
				FP.world.add(new Boom(x, y, 2));
				type = "no";
				return true;
			}
			return false;
			
		}
		public function get_dir():uint
		{
			var r:uint = 0;
			if (!Q.map.get_at(px + 1, py)) r |= E;
			if (!Q.map.get_at(px - 1, py)) r |= W;
			if (!Q.map.get_at(px, py - 1)) r |= N;
			if (!Q.map.get_at(px, py + 1)) r |= S;
			return r;
		}
		
		public function setup():void
		{
			var dir:uint = get_dir();
			if (dir & N) target_angle = angle_n;
			if (dir & S) target_angle = angle_s;
			if (dir & W) target_angle = angle_w;
			if (dir & E) target_angle = angle_e;
		}
		
		override public function update():void
		{
			if (setup_delay)
			{
				setup_delay--;
				if (!setup_delay)
				{
					setup();
				}
			}
			if (Math.abs(angle-(target_angle-360)) < Math.abs(angle-target_angle)) target_angle-= 360;
			if (target_angle > angle) angle += 6;
			if (target_angle < angle) angle -= 6;
			if (Math.abs(angle-target_angle) < 8) angle = target_angle;
			spr.angle = angle;
			debug.text =  angle + "/" + target_angle;
		}
		
		override public function render():void
		{
			if (shadow)
			{
				spr.color = 0;
				spr.alpha = .6;
				spr.render(FP.buffer, new Point(x + 5, y + 5), FP.camera);
				spr.color = 0xffffff;
				spr.alpha = 1;
			}
			if (hit)
			{
				hit--;
				spr.color = (hit & 1) ? 0xff0000 : 0xffff80;
			}
			super.render();
			
			//debug.render(FP.buffer, new Point(x, y), FP.camera);
		}
		
	}
}