package
{
	import flash.display.BlendMode;
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Draw;
	
	// gamer is a classs fo a game entity, controlled either
	// by local player, remote player or AI or nothing
	public class Energy extends Entity
	{
		[Embed(source = "gfx/energy.png")]
		public var GFX:Class;
		
		public var spr:Image = new Image(GFX);
		public static const H:uint = 0;
		public static const V:uint = 1;
		public var dir:uint;
		public var dist:uint;
		public var x1:Number;
		public var y1:Number;
		public var x2:Number;
		public var y2:Number;
		public var color:uint = 0;
		public function Energy(x1:Number, y1:Number,x2:Number, y2:Number,dir:uint,dist:uint)
		{
			this.x1 = x1;
			this.y1 = y1;
			this.x2 = x2;
			this.y2 = y2;
			this.dist = dist;
			this.dir = dir;
			this.x = (x1+x2)/2;
			this.y = (y1+y2)/2;
			spr.blend = BlendMode.ADD;
			graphic = spr;
			spr.centerOrigin();
			if (dir==H) 
			{
				setHitbox(Math.abs(x1 - x2), 32, Math.abs(x1 - x2) / 2, 16);
				if (x1 > x2)
				{
					this.x1 -= 16;
					this.x2 += 16;
				} else {
					this.x1 += 16;
					this.x2 -= 16;
				}
				spr.scaleX = 3;
				spr.scaleY = dist;
				spr.angle = 90;
				
			} else {
				setHitbox(32, Math.abs(y1 - y2), 16, Math.abs(y1 - y2) / 2);
				if (y1 > y2)
				{
					this.y1 -= 16;
					this.y2 += 16;
				} else {
					this.y1 += 16;
					this.y2 -= 16;
				}
				spr.scaleY = dist;
				spr.scaleX = 3;
			}
			
			color = FP.colorLerp(0xc164ea, 0xffffff, Math.random())
			spr.color = FP.colorLerp(color,0,.9);
			
		}

		override public function update():void
		{
			var e:Enemy = collide("enemy", x, y) as Enemy;
			if (!e || !(e is Force))
			{
				FP.world.remove(this);
			}
			if (collide("player", x, y))
			{
				FP.world.add(new Gunspark(Q.player.x, Q.player.y, 1,false));
				Q.player.punch(1);
				//FPz.world.remove(this);
			}
			super.update();
		}
		
		override public function render():void
		{
			super.render();
			var count:uint = dist * 3;
			var sx:Number = x1;
			var sy:Number = y1;
			var dx:Number = x1;
			var dy:Number = y1;
			for (var c:uint = 0; c < count; c++)
			{
				var l:Number = c / (count - 1);
				var d:Number = Math.sin(l * Math.PI);
				dx = FP.lerp(x1, x2, l) + FP.rand(16) - 8;
				dy = FP.lerp(y1, y2, l) + FP.rand(16) - 8;
				Draw.linePlus(sx, sy, dx, dy,color , 1, 2);
				sx = dx;
				sy = dy;
			}
		}
		
	}
}