package
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	
	// gamer is a classs fo a game entity, controlled either
	// by local player, remote player or AI or nothing
	public class Gamer extends Entity
	{
		
		// variables
		public var vx:Number = 0; // velocity
		public var vy:Number = 0;
		public var jumps:uint = max_jumps; // jumps performed
		
		// properties
		public var speed:Number = 10.0; // max velocity
		public var acc:Number = 1.0; // ecceleration
		public var decc:Number = .98; // brakes
		public var max_jumps:uint = 1; // x-iple jump
		public var jumprate:Number = -20.0; // how high
		public var bumprate:Number = 0.0; // wallfallbump rate
		public var antigravity:Number = 1.0; // parachuting
		public var fly:Boolean = false; // disregard for gravity
		public var stationary:Boolean = false; // disregard for everything
		public var manual:Boolean = false; // disregard for input()
		public var wallkick:Boolean = false;
		public var wallkickdir:Number = 0;
		public var hang:Boolean = false;
		public var duck:Boolean = false;
		public var climb:uint = 0;
		public var hangdir:Number = 0;
		public var stomp:uint = 0;
		
		public var hit:uint = 0;
		
		public var hp:int = 10;
		public var max_hp:int = 10;
		
		public var shoot:uint = 0;
		
		
		public var can_walljump:Boolean = false;
		public var can_climb:Boolean = false;
		public var can_shoot:Boolean = false;
		public var can_throw:Boolean = false;
		
		static public var gravity:Number = 1.6; // gravity
		
		// BUTTONS
		static public const UP:uint     = 0x01;
		static public const DOWN:uint   = 0x02;
		static public const LEFT:uint   = 0x04;
		static public const RIGHT:uint  = 0x08;
		static public const SHOOT:uint  = 0x10;
		static public const JUMP:uint   = 0x20;
		static public const SHIT:uint   = 0x40;
		static public const FUCK:uint   = 0x80;
		static public const MULTIJUMP:uint   = 0x100;
		public var spr:Spritemap ;
		
		public function Gamer(x:Number,y:Number)
		{
			this.x = x;
			this.y = y;
		}
		
		// this return buttonpress bitmask, least 8 bits:
		// 0 - UP	
		// 1 - DOWN
		// 2 - LEFT
		// 3 - RIGHT
		// 4 - SHOOT
		// 5 - JUMP
		// 6 - SOMETHING ELSE
		// 7 - SOMETHING ELSER
		public function input():uint 
		{
			// please overload
			return 0;
		}
		
		public function punch(atk:uint):void
		{
			trace("hit");
			if (hit > 8) return;
			if (hit) spr.flipped = !spr.flipped;
			hit = 10;
			vx = -8;
			vy = -12;
			if (spr.flipped) vx *= -1;
			hp -= atk;
			if (hp <= 0 && !Q.level.gameover) Q.level.gameover = 5;
			trace(hp);
			
		}
		
		public function play(str:String):void
		{
			if (shoot) str += "_shoot";
			spr.play(str);
		}
		
		override public function update():void
		{
			// if it doesn't move then... well it doesn't!
			if (stationary) return;
			if (hit) hit--;
			if (collide("level", x, y)) 
			{
				//trace("X1: " + x);
				this.x = x + 5;
				vx = 8;
				vy = 0;
				//trace("X2: " + x);
				return;
			}
			
			var wallleft:Boolean = collide("level", x - 8, y);
			var wallright:Boolean = collide("level", x + 8, y);
			// if not controlled manually (by code) we check input
			if (!manual)
			{
				// get keys!
				var keys:uint = input();
			
				// check left/right!
				
			
				// if flying, then not jumping :P
			
					if (keys & DOWN) hang = false;
					
					if ((keys & UP) && hang)
					{
						climb = 3;
						y -= 32;
						x += 16 * hangdir;
						hang = false;
						
					}
					
				// else, totally jumping :P
					if ((keys & JUMP) && jumps && !duck) 
					{
						vy = jumprate;
						jumps--;
						stomp = 0;
					}else if ((keys & JUMP) && hang && can_climb) 
					{
						vy = jumprate;
						vx = jumprate * hangdir;
						jumps=0;
						stomp = 0;
						hang = false;
					}else if ((keys & JUMP) && wallkick && can_walljump) 
					{
						vy = jumprate;
						vx = jumprate * wallkickdir;
						jumps=0;
						stomp = 0;
					} else if ((keys & JUMP) && (wallleft || wallright) && Math.abs(vy)>1 && can_walljump) 
					{
						vy = jumprate;
						vx = jumprate * (wallleft ? -1 : 1);
						var dodo:Boolean = true;
						if ((keys & LEFT) && wallleft) dodo = false;
						if ((keys & RIGHT) && wallright) dodo = false;
						if (dodo) vx *= .5;
						
						jumps=0;
						stomp = 0;
					}
					
					
					
						if (keys & LEFT && !climb && !duck) { vx -= acc; spr.flipped = true;}
			
						if (keys & RIGHT && !climb && !duck) { vx += acc; spr.flipped = false;}
				
			}
			//trace("X3: " + x);
			// collision detection assumes all objects initially do not collide
			//trace(stomp);
			
			if (shoot)
			{
				shoot--;
			}
			if (stomp) stomp--;
			if (climb) climb--;
			// gravitizing
			if (!(keys & LEFT) && hangdir < 0) hang = false;
			if (!(keys & RIGHT) && hangdir >0) hang = false;
			vy += gravity * antigravity;
			if (vy > 32) vy = 32;
			if (wallkick) 
			{
				if (vy > 8) vy = 8;
			}
			if (hang)
			{
				if (vy > 0) vy = 0;
			}
			// friction
			//vx *= decc;
			if ((keys & (LEFT | RIGHT)) && !duck)
			{
				stomp = 0;
				if (vx > speed) vx = speed;
				if (vx < -speed) vx = -speed;
				if (vx > 0 && keys & LEFT) { play("slideback"); spr.flipped = !spr.flipped; }
				else if (vx < 0 && keys & RIGHT) {play("slideback");spr.flipped = !spr.flipped;}
				else play("run");
			} else {
				if (duck)
				{
					if (vx > 0) vx -= acc/4;
					if (vx < 0) vx += acc / 4;
				} else {
					if (vx > 0) vx -= acc/2;
					if (vx < 0) vx += acc / 2;
				}
				if (Math.abs(vx) < acc / 2) vx = 0;
				if (!stomp)
				{
				if (vx!=0) play("slide");
				else play("idle");
				}
				
			}
			//trace("X4: " + x);
			// ground / head collision
			if (collide("level", x, y + vy))
			{
				
				if (vy < 0) // goes up
				{
					// hit the ceiling
					vy = 0;// -vy * bumprate;
				} else { // falling or standing
					
					// landed, we bump if necessary
					if (vy > 2)
					{
						play("stomp");
						stomp = 10;
						Puff.multi(5, x, y + 32, 4, 1);
					}
					y = Math.round(y / 32) * 32;
					jumps = 0;
					vy = -vy * bumprate;
					jumps = max_jumps;
					
				}
				
				
			} else {
				if (jumps == max_jumps) jumps = 0;
				if (vy > 0 && !stomp) play("fall"); else play("jump");
			}
			//trace("X4.5: " + x);
			// side level collision
			// please note the double collision check
			if (collide("level", x+vx, y) || collide("level", x+vx, y+vy))
			{
				//trace("X4.6: " + x);
				if (vx > 0) // goes up
				{
					x = Math.ceil(x / 32) * 32-12;
				} else { // falling or standing
					x = Math.floor(x / 32) * 32+12;
				}
				//trace("X4.7: " + x);
				wallkick = false;
				
				if ((keys & LEFT) && vx < 0 && vy>4) 
				{ 
					wallkick = true; wallkickdir = -1; 
				}
				//trace("X4.8: " + x);
				if ((keys & RIGHT) && vx > 0 && vy > 4) 
				{
					wallkick = true; wallkickdir = 1;
				}
				//trace("X4.9: " + x);
				if (wallkick && can_walljump) play("wallslide");
				if (wallkick)
				{
					if (!FP.world.collidePoint("level", x + (wallkickdir * (width / 2)) + vx, y)
						&& FP.world.collidePoint("level", x + (wallkickdir * (width / 2)) + vx, bottom))
					{
						trace("hang!");
						hang = true;
						hangdir = wallkickdir;
						play("hang");
						y = Math.ceil(y / 32) * 32;
						vx = 0;
						vy = 0;
					}
				}
				if (!can_walljump) wallkick = false;
				if (!can_climb) hang = false;
				//trace("X4.10: " + x);
				// bump if necessary (or stop)
				vx = -vx * bumprate;
				//trace("X4.11: " + x);
			} else {
				wallkick = false;
				
			}
			//trace("X5: " + x);
			if (hang) play("hang");
			if (climb) play("climb");
			
			duck = false;
			if (jumps == max_jumps && !wallkick && !hang)
			{
				if (Input.check(Key.DOWN))
				{
					
					duck = true;
					
				}
			} 
			if (duck)
			{
				if (Math.abs(vx) < 1) play("duck"); else play("glide");
				setHitbox(24, 32, 12, 0);
			} else {
				setHitbox(24,48,12,16);
			}
			
			if (((Input.pressed(Key.X) && can_shoot) || (Input.pressed(Key.C)) && can_throw) && shoot<5 && !hit)
			{
				
				
				var anim:String = spr.currentAnim;
				anim = anim.split("_shoot").join("");
				spr.play(anim + "_shoot");
				var sx:Number = gunpos[spr.frame][0];
				var sy:Number = gunpos[spr.frame][1];
				var v:Number = gunpos[spr.frame][2];
				sy += y-32;
				if (spr.flipped)
				{
					sx = right - sx;
					v *= -1;
				} else {
					sx = left + sx;
				}
				if (Input.pressed(Key.C))
				{
					FP.world.add(new Grenade(sx,sy,v*8,-8));
					shoot = 10;
				} else {
					FP.world.add(new Bullet(sx, sy, v));
					shoot = 10;
				}
				
				//trace(spr.currentAnim + " / " + spr.frame);
			}
			
			
			
			// apply velocity!
			x += vx;
			y += vy;
			
			
			
			// it's as simple as that!
			
			
		}
		
		override public function render():void
		{
			if (!(hit&1)) super.render();
		}
		
		public var gunpos:Array =
		[
			[55, 16, 1], 
			[55, 16, 1], 
			[55, 16, 1], 
			[55, 16, 1], 
			[55, 16, 1], 
			
			[61,21, 1], 
			[60,23, 1], 
			[61,21, 1],
			[61,16, 1],
			[58, 15, 1],
			
			[59,20, 1],
			[59,23, 1],
			[61,21, 1],
			[62,17, 1],
			[62, 16, 1],
			
			[51,23, 1],
			[58,17, 1],
			[56,27, 1],
			[51, 39, 1],
			[18, 19, -1],
			
			[5,36, -1],
			[54,44, 1],
			[42,41, 1],
		
		
			[55, 16, 1], 
			[61,21, 1], 
			[60,23, 1], 
			[61,21, 1],
			[61,16, 1],
			[58,15, 1],
			[59,20, 1],
			[59,23, 1],
			[61,21, 1],
			[62,17, 1],
			[62,16, 1],
			[51,23, 1],
			[3,24, -1],
			[58,17, 1],
			[56,27, 1],
			[51,39, 1],
			[18,19, -1],
			[5,36, -1],
			[54,44, 1],
			[42, 41, 1],
			[3,24, -1],
		];
		
	}
}