package
{
	import flash.geom.Point;
	import net.flashpunk.Entity;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Draw;
	
	// gamer is a classs fo a game entity, controlled either
	// by local player, remote player or AI or nothing
	public class Grenade extends Entity
	{
		[Embed(source = "gfx/grenade.png")]
		public var GFX:Class;
		public var spr:Image = new Image(GFX);
		public var vx:Number = 0;
		public var vy:Number = 0;
		public var delay:uint = 30 * 2;
		public var bumprate:Number = .25;
		public var bumps:uint = 0;
		public var va:Number = 0;
		public var immune:uint = 2;
		public function Grenade(x:Number,y:Number,vx:Number,vy:Number)
		{
		
			bumps = 0;
			this.x = x;
			this.y = y;
			this.vx = vx;
			this.vy = vy;
			this.x += vx;
			this.y += vy;
			graphic = spr;
			spr.centerOrigin();
			setHitbox(8, 8, 4, 4);
			//spr.color = 0xe02020;
			va = -vx * 20;
		}

		
		override public function update():void
		{
			va = vx * 2;
			spr.angle += va;
			vy += Gamer.gravity;
			if (bumps > 3) bumprate = 0;
			if (bumps)
			{
				if (Math.abs(vx) < .5) vx = 0;
				if (Math.abs(vy) < Gamer.gravity) vy = 0;
			}
			if (immune) immune--;
			if (collide("level", x, y + vy))
			{
				
				if (vy < 0) // goes up
				{
					// hit the ceiling
					vy = 0;// -vy * bumprate;
				} else { // falling or standing
					
					vy = -vy * bumprate;
					vx *= .5;
					
					
				}
				bumps++;
				
				
			} 
			
			// side level collision
			// please note the double collision check
			if ((collide("level", x + vx, y) || collide("level", x + vx, y + vy))  && !immune)
			{
				
				if (vx > 0) // goes up
				{
					
				} else { // falling or standing
					
				}
				bumps++;
				
				// bump if necessary (or stop)
				vx = -vx * bumprate;
				
			}
			x += vx;
			y += vy;
			
			if (delay) delay--;
			if (delay < 30) 
			{
				spr.color = (delay & 1) ? 0xff0000 : 0xffff80;
			}
			if (!delay) 
			{
				FP.world.remove(this);
				FP.world.add(new Boom(x, y,2,true));
			}
			super.update();
		}
		
		override public function render():void
		{
			
			super.render();
		}
		
	}
}